shell脚本基础

编程基础

v程序:指令+数据

v程序编程风格:

过程式:以指令为中心,数据服务于指令(适合小型程序)

对象式:以数据为中心,指令服务于数据(适合大型程序)

vshell程序:提供了编程能力,解释执行

程序的执行方式

v计算机:运行二进制指令;

v编程语言:

低级:汇编

高级:

编译:高级语言–>编译器–>目标代码

java,C#

解释:高级语言–>解释器–>机器代码

shell, perl, python

编程基本概念

v编程逻辑处理方式:

顺序执行

循环执行

选择执行

vshell编程:过程式、解释执行

编程语言的基本结构:

数据存储:变量、数组

表达式: a + b

语句:if

Shell脚本

shell脚本基础

shell脚本是包含一些命令或声明,并符合一定格式的文本文件

格式要求:首行shebang机制

#!/bin/bash(.sh后缀结尾)

#!/usr/bin/python(.py后缀结尾)

#!/usr/bin/perl(.pl后缀结尾)

shell脚本的用途有:

自动化常用命令

执行系统管理和故障排除

创建简单的应用程序

处理文本或文件

创建shell脚本

v第一步:使用文本编辑器来创建文本文件

第一行必须包括shell声明序列:#!

#!/bin/bash

添加注释

注释以#开头

v第二步:运行脚本

给予执行权限,在命令行上指定脚本的绝对或相对路径

chmod +x /PATH/TO/SCRIPT_FILE

/PATH/TO/SCRIPT_FILE

直接运行解释器,将脚本作为解释器程序的参数运行

bash  /PATH/TO/SCRIPT_FILE

运行脚本

让通过配置文件定义的特性立即生效

(1)    通过命令行重复定义一次

(2)    让shell进程重读配置文件

#source /PATH//FROM/FILE

#. /PATH/FROM/FILE

改变.bash_profile里面PATH变量,使运行脚本的执行路径改变

root用户存放的PATH变量

PATH=$PATH:$HOME/bin

普通用户存放的PATH变量 ,有个隐藏的目录.local,如果不存在可以自己创建

PATH=$PATH:$HOME/.local/bin:$HOME/bin

shell脚本范例

v#!/bin/bash

v#author:wang

v#Version:1.0

v#Description:Thisscriptdisplayssomeinformationaboutyour#environment

echo"Greetings.Thedateandtimeare$(date)"echo"Yourworkingdirectoryis:$(pwd)"

脚本调试

vbash-n /path/to/some_script

检测脚本中的语法错误

vbash-x /path/to/some_script

调试执行(也具有语法检测功能)

会把执行过程显示出来

+和++是层次结构,++是先执行的那层

变量

1.变量

PATH\PWD\USER\OLDPWD\HISTSIZE\HISTFILESIZE\SHELL\HOME\PS1\HISTCONTROL\HISTTIMEFORMAL\UID\HISTFILE

2.命名的内存空间

数据存储方式:字符

数值:整型,浮点型

布尔值:

3.变量类型

作用:1、数据存储格式

2、参与的运算

3、表示的数据范围

类型: 字符

数值:整型、浮点型

4.编程程序语言分类:

1.强类型:定义变量时必须指定类型、参与运算必须符合类型要求;调用未声明变量会产生错误。如java,python

2.弱类型:无须指定类型,默认均为字符型;参与运算会自动进行隐式类型转换;变量无须事先定义可直接调用如:bash 不支持浮点数

5.变量命名法则:

1、不能使程序中的保留字:例如if,for;

2、只能使用数字、字母及下划线,且不能以数字开头

3、见名知义

4、统一命名规则:驼峰命名法(大驼峰StudentName,小驼峰studentName)

6.bash中变量的种类

1)分类标准:根据变量的生效范围等标准

本地变量:生效范围为当前shell进程;对当前shell之外的其它shell进程,包括当前shell的子shell进程均无效

echo里面表达的是在vartest.sh的脚本中有个localvar1的变量他的值为localvar1

#!/bin/bash

localvar1=haha

echo"vartest1.sh:localvar1=$localvar1"

此时echo$localvar1 没有反应,这说明自己定义的脚本只能自己使用,只对当前shell有效

[root@localhost ~]# bash vartest1.sh

vartest1.sh:localvar1=haha

sleep  20

运行vartest1脚本的时候相当于在bash的子进程shell中,但是echo$localvar1是在bash进程中的,所以他们不是在一个shell进程中

            wKiom1ev5AyxKzt6AAAJhCHuwek064.png-wh_50              

本地变量不能给子进程使用的例子:

在自己的脚本显示自己的变量,在自己的脚本显示localvar1的变量

#!/bin/bash

Lacalvar2=xixi

echo "vartest2.sh:localvar2=$localvar2"

echo "vartest2.sh:localvar1=$localvar1"

sleep 10

vartest1中去调用vartest2,此时vartest1vartest2是父子关系

#!/bin/bash

Localvar1=haha

echo "vartest1.sh:localvar1=$localvar1"

./vartest2.sh

Sleep 10

在子进程中尝试显示父进程的变量显示失败

[root@localhost~]# ./vartest1.sh

vartest1.sh:localvar1=haha

vartest2.sh:localvar2=xixi

vartest1.sh:localvar1=

原因是因为本地变量不能给子进程使用

wKioL1ev49zjTB9JAAAGoIdfw0o834.png-wh_50

环境变量:生效范围为当前shell进程及其子进程

局部变量:生效范围为当前shell进程中某代码片断(通常指函数)

位置变量$1, $2, …来表示,用于让脚本在脚本代码中调用通过命令行传递给它的参数

特殊变量:$?,$0, $*, $@, $#

2)本地变量

v变量赋值:name=‘value’

v可以使用引用value:

(1)可以是直接字串;name=“root"

(2)变量引用:name=${command}

(3)命令引用:name=$(COMMAND)

v变量引用:${name}, $name

"":弱引用,其中的变量引用会被替换为变量值

'':强引用,其中的变量引用不会被替换为变量值,而保持原字符串

v显示已定义的所有变量:set

v删除变量:unset name

练习

v1、编写脚本/root/bin/systeminfo.sh,显示当前主机系统信息,包括主机名,IPv4地址,操作系统版本,内核版本,CPU型号,内存大小,硬盘大小。

wKioL1ev5CCB_SEbAABpd0NgiW4218.png-wh_50

v2、编写脚本/root/bin/backup.sh,可实现每日将/etc/目录备份到/root/etcYYYY-mm-dd

wKiom1ev5C6BidIvAAAjJF2QDJQ350.png-wh_50

v3、编写脚本/root/bin/disk.sh,显示当前硬盘分区中空间利用率最大的值

wKioL1ev5D7w09QlAAAW4CYApes484.png-wh_50

v4、编写脚本/root/bin/links.sh,显示正连接本主机的每个远程主机的IPv4地址和连接数,并按连接数从大到小排序wKiom1ev5E2BJKqdAAAVoBo8ryA229.png-wh_50

3)环境变量

v变量声明、赋值:

export name=VALUE

declare -x name=VALUE

声明完之后在脚本中显示

v变量引用:$name, ${name}

            $ab这种就需要加大括号${a}b.

v显示所有环境变量export

env

printenv

v删除:unset name

vbash有许多内建的环境变量:PATH, SHELL, USRE,UID,HISTSIZE, HOME, PWD, OLDPWD, HISTFILE, PS1

环境变量对子进程生效

4)只读和位置变量

v只读变量:常量,只能读,但不能修改和删除

readonlyname

declare-r name

         一般是常量中会使用

                   declare–rx name 表示既是一个常量又是一个环境变量

         但是随shell进程终止而终止

v位置变量:在脚本代码中调用通过命令行传递给脚本的参数

$1,$2, …:对应第1、第2等参数,shift [n]换位置

$0:命令本身

$*:传递给脚本的所有参数,全部参数合为一个字符串

$@:传递给脚本的所有参数,每个参数为独立字符串

$#:传递给脚本的参数的个数

重点$@ $* 只在被双引号包起来的时候才会有差异

示例:判断给出的文件的行数

linecount="$(wc-l$1| cut -d' ' -f1)"

echo"$1 has $linecountlines."

算术运算

vbash中的算术运算:help let

+, – , * , / , %取模(取余),**(乘方)

1.实现算术运算:

(1)   let var=算术表达式

相等的表达方式:

let var =var*5

let var*=5

(2)var=$[算术表达式]

(3)var=$((算术表达式))

(4)var=$(expr arg1 arg2 arg3 …)

   expr 1  +  2   屏幕上就出现3

   expr $var  +  2   屏幕就会出现数值

   可以判断变量是否为整数:expr  $var  +0  就可以了

[root@localhost ~]# var=111

[root@localhost ~]# expr $var + 0

111

[root@localhost ~]# echo $?

0

[root@localhost ~]# expr $var + 0&> /dev/null

[root@localhost ~]# echo $?

0

 

但是乘法的时候需要转意:

[root@localhost ~]# expr 2 * 3

expr: syntax error

[root@localhost ~]# expr 2 \* 3

6

(5)declare –i var= 数值

[root@localhost ~]# declare -ii=100

[root@localhost ~]# declare -ij=200

[root@localhost ~]# declare -im=i+j

[root@localhost ~]# echo $m

300

(6)echo ‘算术表达式’| bc

vbash有内建的随机数生成器:$RANDOM1-32767

echo $[$RANDOM%50] 0-49之间随机数

如果要表示2-51:echo $[$RANDOM%50+2]

表示1-n:echo $[$RANDOM%N+1]

2.赋值

v增强型赋值:

+=,-=, *=, /=, %=

vletvarOPERvalue

例如:let count+=3

自加3后自赋值

[root@localhost ~]# echo $i

100

[root@localhost ~]# let i++

[root@localhost ~]# echo $i

101

[root@localhost ~]# let i–

[root@localhost ~]# echo $i

100

[root@localhost ~]# let ++i

[root@localhost ~]# echo $i

101

[root@localhost ~]# let –i

[root@localhost ~]# echo $i

100

v自增,自减:

letvar+=1

letvar++

letvar-=1

letvar—

[root@localhost ~]# i=100

[root@localhost ~]# let v=i++

[root@localhost ~]# echo $i

101

[root@localhost ~]# echo $v

100

练习

v练习1:写一个脚本/root/bin/sumid.sh,计算/etc/passwd文件中的第10个用户和第20用户的ID之和

wKioL1ev5F_QO2EPAAAQfU9ObkM575.png-wh_50

v练习2:写一个脚本/root/bin/sumspace.sh,传递两个文件路径作为参数给脚本,计算这两个文件中所有空白行之和

wKioL1ev5GnDZAqKAAAQMbiRIPY516.png-wh_50

v练习3:写一个脚本/root/bin/sumfile.sh,统计/etc, /var, /usr目录中共有多少个一级子目录和文件

wKiom1ev5ICzLbtkAAAITQY8Av4899.png-wh_50

逻辑运算

vtrue,false

1,0

v与:

11= 1

10= 0

01 = 0

00 = 0

v:

11= 1

10= 1

01= 1

00= 0

v非:!

!1 = 0

!0 = 1

v短路运算:

短路与:

第一个为0,结果必定为0

第一个为1,第二个必须要参与运算;

短路或:

第一个为1,结果必定为1

第一个为0,第二个必须要参与运算;

v异或:^

异或的两个值相比 ,相同为假,不同为真

例如:#command1 && command2

command1为“假”,则command2 不会再执行

否则,command1为“真”,则command2必须执行

#command1 || command2

command1为“假”,则command2 必须执行

否则,command1为“真”,则command2不会再执行

要实现user1用户不存在就添加用户user1:id user1 || useradd user1

聚集命令

有两种聚集命令的方法:

1)复合式

复合式:date; who | wc -l

命令会一个接一个地运行

先执行date,再执行who|wc -l

[root@localhost ~]# who

root     pts/0        2016-08-13 14:17 (10.1.250.108)

[root@localhost ~]# date;who |wc -l

Sat Aug 13 18:26:19 CST 2016

1

2)子shell

shell(date;who | wc -l ) >>/tmp/trace

所有的输出都被发送给单个STDOUTSTDERR

[root@localhost ~]# (date;who |wc-l) >>/tmp/trace

[root@localhost ~]# cat/tmp/trace

Sat Aug 13 18:28:23 CST 2016

1

两个命令一起执行可以使用()

[root@localhost ~]# (date;who)|wc -l

2

退出状态

v进程使用退出状态来报告成功或失败

0代表成功,1255代表失败

$? 变量保存最近的命令退出状态

v例如:

$ping-c1 -W1 hostdown&>/dev/null  

$echo$?

-c1为只发一个包;-W1为等待1秒,默认5秒(大写w)。

退出状态码

vbash自定义退出状态码

exit [n]:自定义退出状态码;  exit 100

注意:脚本中一旦遇到exit命令,脚本会立即终止;终止退出状态取决于exit命令后面的数字

注意:如果未给脚本指定退出状态码,整个脚本的退出状态码取决于脚本中执行的最后一条命令的状态码

exit例子:

假如编下面的脚本:

#!/bin/bash

echo xxx;(echo zzz ;exit)

echo yyy

就会显示:

[root@localhost ~]# bash f2.sh

xxx

zzz

yyy

相当于在xxx下面调用一个子进程,子进程内容为echo  yyy

条件测试

1判断某需求是否满足,需要由测试机制来实现;

专用的测试表达式需要由测试命令辅助完成测试过程;

2评估布尔声明,以便用在条件性执行中

若真,则返回0

若假,则返回1

3测试命令:

test EXPRESSION

[ EXPRESSION  ](空格)  [ $a = $b ] [ $a == $b ]

[[ EXPRESSION  ]](空格)[[ $a = $b ]]  [[ $a == $b ]]

尽量使用双中括号

注意:EXPRESSION前后必须有空白字符

注意:测试命令中其实只要括号内有东西就为真(空格也算),不一定非得比较,[ “ “]其结果为真。可以查看一个变量是否被定义过,没被定义过的则为假。

4)条件性的执行操作符

v根据退出状态而定,命令可以有条件地运行

&&代表条件性的ANDTHEN

||代表条件性的ORELSE

v例如:

$grep-qno_such_user/etc/passwd\

||echo'Nosuchuser'

Nosuchuser

$ping-c1-W2station1&>/dev/null\

>&&echo"station1isup"\

>||(echo'station1isunreachable';exit1)

station1isup

test命令

v长格式的例子:

$test"$A"=="$B" && echo"Stringsareequal"(比较字符串用==

$test“$A”-eq “$B” &&echo"Integersareequal"(比较数字用-eq

v简写格式的例子:

$["$A"=="$B"]&& echo"Stringsareequal"

$["$A"-eq"$B"]&& echo"Integersareequal"

1数值测试

-gt:是否大于;greaterthan

-ge:是否大于等于;greaterand equal

-eq:是否等于;equal

-ne:是否不等于;not equal

-lt:是否小于;less than

-le:是否小于等于;less anequal

2字符串测试

==:是否等于;

>:ascii码是否大于ascii

<:是否小于

!=:是否不等于

=~:左侧字符串是否能够被右侧的PATTERN所匹配

注意此表达式一般用于[[ ]]中;

-z "STRING":字符串是否为空,空为真,不空为假

-n "STRING":字符串是否不空,不空为真,空为假

注意:用于字符串比较时的用到的操作数都应该使用引号

字符串比较大于小于号必须转义,即加反斜线。 
         
字符串比较的顺序是按ASCII表的顺序的,大写字母比小写字母的值小

练习

v1、写一个脚本/root/bin/argsnum.sh,接受一个文件路径作为参数;如果参数个数小于1,则提示用户“至少应该给一个参数”,并立即退出;如果参数个数不小于1,则显示第一个参数所指向的文件中的空白行数

[ $# -lt 1 ] && echo "至少给用户一个参数" || grep'^$' $1 | wc -l

wKioL1ev5JqDhjgEAAAHtu8kgfQ998.png-wh_50

v2、写一个脚本/root/bin/hostping.sh,接受一个主机的IPv4地址做为参数,测试是否可连通。如果能ping通,则提示用户“该IP地址可访问”;如果不可ping通,则提示用户“该IP地址不可访问”

ping -c1 -W1 $1 && echo "该用户地址可以访问" || echo "ip地址不可以访问"

 wKiom1ev5KXh0vRiAAAIUGUH-XE910.png-wh_50

 v3、如果最大磁盘利用率大于百分之20,就报错

maxuse=`df | grep "dev/sd" | tr -s ' ' ':' |cut -d: -f5 | sed's@%@@' | sort -n | tail -1`

max=20

[[ maxuse -ge max ]] && echo " wall disk will be full!"

wKiom1ev5K_BpeZ6AAAN6NuV6pU104.png-wh_50

3文件测试

1)在性测试

-aFILE:同-e

-e FILE: 文件存在性测试,存在为真,否则为假;

2)存在性及类别测试

-bFILE:是否存在且为块设备文件;

-cFILE:是否存在且为字符设备文件;

-d FILE:是否存在且为目录文件;

-f FILE:是否存在且为普通文件;(存在为真)

-hFILE -LFILE:存在且为符号链接文件;

-pFILE:是否存在且为命名管道文件;

-SFILE:是否存在且为套接字文件;

3)件权限测试:

-rFILE:是否存在且可读

-wFILE: 是否存在且可写

-xFILE: 是否存在且可执行

 

看一个目录的权限要看实际权限,不能看———,root账号权限对它是不起作用:

4)文件特殊权限测试:

-gFILE:是否存在且拥有sgid权限;

-uFILE:是否存在且拥有suid权限;

-kFILE:是否存在且拥有sticky权限;

5)文件大小测试:

-sFILE: 是否存在且非空;

非空为真,空为假

6)文件是否打开:

-tfd : fd表示文件描述符是否已经打开且与某终端相关

-NFILE:文件自上一次被读取之后是否被修改过(读先发生,写后发生)就是读的时间比较旧

-OFILE:当前有效用户是否为文件属主

-GFILE:当前有效用户是否为文件属组

7)双目测试:

FILE1–ef  FILE2 : FILE1FILE2是否指向同一个设备上的相同inode(硬链接)

FILE1–nt  FILE2 : FILE1是否新于FILE2;(修改的时间)

FILE1–ot  FILE2 : FILE1是否旧于FILE2;(修改的时间)

8)组合测试条件

v第一种方式:

COMMAND1&& COMMAND2 并且

COMMAND1|| COMMAND2 或者

!COMMAND 

如:[ -e FILE ] && [ -r FILE ]

v第二种方式:

EXPRESSION1-a EXPRESSION2 并且

EXPRESSION1-o EXPRESSION2 或者

!EXPRESSION

必须使用测试命令进行,即进行test或者[ ];

意思是只要主机名没有定义或者主机名为默认就改为www

#[ -z “$HOSTNAME” -o $HOSTNAME "==\

"localhost.localdomain"] && hostname www.magedu.com

判断/bin/cat是否为可执行文件,如果是就调用

#[ -f /bin/cat -a -x /bin/cat ] && cat /etc/fstab

练习

v1chmod -rw /tmp/file1,编写脚本/root/bin/per.sh,判断当前用户对/tmp/fiile1文件是否不可读且不可写

不管对文件设置什么权限对root用户是不管用的,所以我们要去普通用户查看

[ ! -r /tmp/file1 -a ! -w /tmp/file1 ] || echo "用户对文件不可读不可写"

wKioL1ev5MDCD5U6AAAGpgSNr0s764.png-wh_50

v2、编写脚本/root/bin/nologin.shlogin.sh,实现禁止和充许普通用户登录系统。

[ -f /etc/nologin ] && echo "已经禁止普通用户登入" || (touch /etc/nologin; echo "禁止用户登入" )

wKioL1ev5MyToPgMAAAJz4xsD9Y054.png-wh_50

[ -f /etc/nologin ] && rm -rf/etc/nologin || echo "普通用户本身就可以登入系统"

wKiom1ev5NrgCH5WAAAX16bizmA106.png-wh_50

原创文章,作者:Jagger,如若转载,请注明出处:http://www.178linux.com/35281

(0)
上一篇 2016-08-15 12:05
下一篇 2016-08-15 12:06

相关推荐

  • IO,用户与组管理,文件,目录权限管理

           文件统配匹配模式:元字符文件名通配符*匹配任意长度的任意字符[root@localhost ~]# ls /root/D*/root/Desktop  /root/Documents  /root/Downloads ?匹配单个任意字符[root@localhost ~]# …

    Linux干货 2016-08-05
  • centos启动流程

    1、加电自检(power on system test POST) 加电,就是按下电源键使电脑主机通电,在诸多硬件设备中有一个被称为CMOS设备在计算机启动的过程中起到了至关重要的作用,CMOS在加电之后会启动保存在它上面的BIOS程序,即基本输入输出系统(Basic Input Output System)。自检,主要是检测各…

    Linux干货 2016-09-11
  • 压缩与解压

        compress 命令使用“Lempress-Ziv”编码压缩数据文件。compress是个历史悠久的压缩程序,文件经它压缩后,其名称后面会多出”.Z”的扩展名。当要解压缩时,可执         &nbsp…

    2017-08-14
  • 用户与用户组相关的配置文件与命令总结

    Linux 中用户与用户组相关的配置文件与命令总结 用户与用户组 UID、GID 名称解析与解析库(passwd、group、shadow、gshadow) 用户信息库/etc/passwd 用户密码信息/etc/shadow 组的信息库/etc/group 组的密码信息/etc/gshadow 用户管理命令 用户组管理命令 用户与用户组 Linux是一种多…

    2016-10-23
  • 马哥教育网络班21期-第九周课程练习

    "1、写一个脚本,判断当前系统上所有用户的shell是否为可登录shell(即用户的shell不是/sbin/nologin);分别这两类用户的个数;通过字符串比较来实现; #!/bin/bash # declare -i login_user=0 declare -i nologin_user=0 whil…

    Linux干货 2016-09-15
  • N22-第二周作业

    Linux上的文件管理类命令有哪些,其常用使用方法及其相关示例演示。 文件管理类命令有:cp,mv,rm cp:复制文件或者目录   单源复制:cp [OPTION]… [-T] SOURCE DEST        多源复制:cp [OPTION]… SOURCE… DI…

    Linux干货 2016-09-19